#if !defined(_GLOBALS_H_)
#define _GLOBALS_H_

#include "stdafx.h"

#define _Version_  "3.6.1"
#define EscKey          27
#define SpaceKey        32
#define EnterKey        13
#define UpKey           72
#define DownKey         80
#define PageUpKey       73
#define PageDownKey     81

#if !defined(_MAX_DRIVE)
#define _MAX_DRIVE       3
#endif
#if !defined(_MAX_DIR)
#define _MAX_DIR         66
#endif
#if !defined(_MAX_PATH)
#define _MAX_PATH        80
#endif

#if defined(_MAX_FNAME)
#undef _MAX_FNAME
#endif
#define _MAX_FNAME       9
#if defined(_MAX_EXT)
#undef _MAX_EXT
#endif
#define _MAX_EXT         4

#if !defined(_A_NORMAL)
#define _A_NORMAL   0x00
#endif
#if !defined(_A_RDONLY)
#define _A_RDONLY   0x01
#endif
#if !defined(_A_HIDDEN)
#define _A_HIDDEN   0x02
#endif
#if !defined(_A_SYSTEM)
#define _A_SYSTEM   0x04
#endif
#if !defined(_A_SUBDIR)
#define _A_SUBDIR   0x10
#endif
#if !defined(_A_ARCH)
#define _A_ARCH     0x20
#endif

#if !defined(_MAX_LABEL)
#define _MAX_LABEL  33
#endif

#define _MB_ 1048576				//Megabyte
#define _GB_ 1073741824				//Gigabyte
#define _TB_ 1099511627776			//Terabyte
#define _PB_ 1125899906842624		//Petabyte
#define _EB_ 1152921504606846976	//Exabyte (64 bits maps 8 of these)

#if !defined(__COLORS)
#define __COLORS

enum COLORS {
    BLACK,
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};

#endif

struct dirinfo {
	unsigned      TFiles;
	unsigned      TDirectories;
	char          Path[_MAX_PATH];
	char          DLabel[_MAX_LABEL];
	char          DriveSize[10];
	char          DriveFree[10];
	char          TBytes[10];
	char          UBytes[10];
	unsigned char Columns;
	unsigned char LLen;
};

struct cbits {
	int sort     : 3;	//0-7
	int dplace   : 2;	//0-3
	int display  : 4;	//0 - size, 1 - attributes, 2 - date/time, 3 - long format
	int reverse  : 1;
	int dformat  : 1;
	int dcolor   : 1;
	int dclear   : 1;
	int dbrowse  : 1;
	int dansi    : 1;
	int sname    : 1;
	int cflags   :11;	//sort 1, dplace 2, reverse 4, dformat 8, dcolor 16, dcolumns 32, dclear 64
						//dbrowse 128, dansi 256, path 512, short 1024
};

struct date_time {
	unsigned second : 6;
	unsigned minute : 6;
	unsigned fhour  : 5;
	unsigned day    : 5;
	unsigned month  : 4;
	unsigned year   :10;
};

struct file_list {
	char          name[9];
	char          ext[4];
	char          attrib;
	long unsigned size;
	date_time     tdate;
};

struct tdata {
	SMALL_RECT window;
	unsigned   columns;
	unsigned   rows;
	HANDLE     screen;
	WORD       Oattrib;
	WORD       Cattrib;
};

extern _finddata32_t Entrie;            //Will need replacing.

extern cbits bgiven;            //my own structues, should be fine
extern dirinfo DInfo;
extern tdata tscreen;
extern file_list *flist;
extern unsigned long TList;
extern unsigned TRows;

extern void textval(char*,unsigned long,unsigned long,int);
extern int getswitch(char *);
extern WORD gcolor(char *);
extern void sortlist(void);
extern char readkey(void);
extern void tcolor(WORD);
extern void ShowNoFiles(char *);
extern void showhelp(void);
extern void showerr(int);
extern void ShowLine(unsigned,char *);
extern void ParseEnv(char *);
extern void qswap(unsigned,unsigned);

extern int cleanpath(char *);  //Direct Drive access, needs tweaking.
extern int getdirinfo(void);
extern int getlist(void);

extern int getcur(void);        //Direct Video Access, replace and calling functions
extern void c_print(char *);    //should be fine.
extern void sclear(void);
extern void scrlback(void);
extern void lastrow(void);
extern void ClearLine(void);
extern void scrlfor(void);
extern void scurs(BOOL);

#endif
