#include "stdafx.h"

int cleanpath(char *Working) {

	char drive[_MAX_DRIVE], dir[_MAX_DIR], name[_MAX_FNAME], ext[_MAX_EXT];
	char tpath[_MAX_PATH];
	int cdrive = _getdrive();
	ULONG dMask;
	unsigned i, pdrive, c;
	intptr_t fHandle;

	if (_fullpath(tpath,Working,_MAX_PATH) == NULL) return(-4);

	_splitpath_s(tpath,drive,_MAX_DRIVE,dir,_MAX_DIR,name,_MAX_FNAME,ext,_MAX_EXT);

	if (((char)cdrive + 'A' - '\1') != drive[0]) {
		pdrive = unsigned(drive[0] - 'A');
		dMask = _getdrives();
		for (i = 0; i < pdrive; i++)
			dMask = (dMask >> 1);
		if(!(dMask & 1)) return(-6);		
	}

	if (name[0] == '\0') {
		name[0] = '*';
		name[1] = '\0';
		if (ext[0] == '\0') {
			ext[0] = '.';
			ext[1]= '*';
			ext[2] = '\0';
		}
	}

	_makepath_s(Working,(_MAX_PATH / 2),drive,dir,"","");

	i = 0;
	do ++i; while (Working[i] != '\0');
	
	if (i > 3) {
		pdrive = SetErrorMode(SEM_FAILCRITICALERRORS);
		if (Working[i - 1] == '\\') Working[--i] = '\0';
		fHandle = _findfirst32(Working, &Entrie);
		if (fHandle < 0) {
			_findclose(fHandle);
			SetErrorMode(pdrive);
			return(-5);
		}
		_findclose(fHandle);
		SetErrorMode(pdrive);
	}
	

	if (Working[i - 1] != '\\')	Working[i++] = '\\';
	pdrive = 0;
	while ((name[pdrive] != '\0') && (i < _MAX_PATH)) Working[i++] = name[pdrive++];
	if (i == _MAX_PATH) return(-9);
	pdrive = 0;
	while ((ext[pdrive] != '\0') && (i < _MAX_PATH )) Working[i++] = ext[pdrive++];
	if (i == _MAX_PATH) return(-9);
	Working[i] = '\0';

	if ((i + 4) >= _MAX_PATH) return(0);
	c = 0;
	while (Working[c] != '\0') if ((Working[c] == '*') || (Working[c] == '?')) return(0); else ++c;

	fHandle = _findfirst32(tpath, &Entrie);
	if (fHandle >= 0)
		if (!(Entrie.attrib & _A_SUBDIR)) {
			_findclose(fHandle);
			return(0);
		} else {
			if (Working[i - 1] != '\\') Working[i++] = '\\';
			Working[i++] = '*';
			Working[i++] = '.';
			Working[i++] = '*';
			Working[i] = '\0';
		}
	else return(0);

	_findclose(fHandle);

	return(0);
}

int getdirinfo(void) {

	unsigned i = 0, flag = 0;
	int c = 0;
	unsigned long x = 0;
	unsigned long DriveBytes = 0, FreeBytes = 0, TotalBytes = 0, UsedBytes = 0;
	unsigned DBOverflow = 0, FBOverflow = 0, TBOverflow = 0, UBOverflow = 0, BlockSize = 0;
	char rootp[4] = "", filter = '\0';
	char const uflow[7] = "< 1 KB";
	diskfree_t Free;
	intptr_t fHandle;

	for (i = 0; i < 3; i++)
		rootp[i] = DInfo.Path[i];
	rootp[i] = '\0';

	_getdiskfree(DInfo.Path[0] - 'A' + 1, &Free);

	BlockSize = Free.bytes_per_sector * Free.sectors_per_cluster;

	for (i = 0; i < BlockSize; i ++) {
		DriveBytes += Free.total_clusters;
		if (DriveBytes < Free.total_clusters) ++DBOverflow;
		FreeBytes += Free.avail_clusters;
		if (FreeBytes < Free.avail_clusters) ++FBOverflow;
	}

	GetVolumeInformationA(rootp,DInfo.DLabel,33,NULL,NULL,NULL,NULL,NULL);

	i = 0;
	while (DInfo.DLabel[i] != '\0') ++i;
	DInfo.LLen = char(i);

	fHandle = _findfirst32(DInfo.Path, &Entrie);
	if (fHandle >= 0) c = 0; else c = -1;

	while (c == 0) {
		if (!(Entrie.attrib & _A_SUBDIR) || ((bgiven.dplace & 3) != 3)) {
			x = Entrie.size / BlockSize;
			if ((Entrie.size % BlockSize) != 0) ++x;
			UsedBytes += (x * BlockSize);
			if (UsedBytes < (x * BlockSize)) ++UBOverflow;
			TotalBytes += Entrie.size;
			if (TotalBytes < Entrie.size) ++TBOverflow;
			if (Entrie.attrib & _A_SUBDIR) {
				++DInfo.TDirectories;
				if (DInfo.TDirectories == 0) return(-7);
			} else {
				++DInfo.TFiles;
				if (DInfo.TFiles == 0) return(-7);
			}
		}
	c = _findnext32(fHandle,&Entrie);
	}

	_findclose(fHandle);

	if (tscreen.columns < 40) {
		if ((DBOverflow == 0) && (DriveBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveSize[c] = uflow[c];
		else textval(DInfo.DriveSize,DBOverflow,DriveBytes,6);
		if ((FBOverflow == 0) && (FreeBytes < 1000)) for (c = 0; c < 7; c++) DInfo.DriveFree[c] = uflow[c];
		else textval(DInfo.DriveFree,FBOverflow,FreeBytes,6);
	} else {
		textval(DInfo.DriveSize,DBOverflow,DriveBytes,9);
		textval(DInfo.DriveFree,FBOverflow,FreeBytes,9);
	}

	if (tscreen.columns < 60) {
		if ((TBOverflow == 0) && (TotalBytes < 1000)) for (c = 0; c < 7; c++) DInfo.TBytes[c] = uflow[c];
		else textval(DInfo.TBytes,TBOverflow,TotalBytes,6);
		if ((UBOverflow == 0) && (UsedBytes < 1000)) for (c = 0; c < 7; c++) DInfo.UBytes[c] = uflow[c];
		else textval(DInfo.UBytes,UBOverflow,UsedBytes,6);
	} else {
		textval(DInfo.TBytes,TBOverflow,TotalBytes,9);
		textval(DInfo.UBytes,UBOverflow,UsedBytes,9);
	}

	return(0);
}

int getlist(void) {

	unsigned i = 0, c = 0, x = 0, flag = 0, m = 0;
	intptr_t fHandle;
	tm ftime;
	char sPath[_MAX_PATH], sName[13];
	DWORD u = 0;

	while (DInfo.Path[i] != '\0') 
		if (DInfo.Path[i++] == '\\') flag = i;
	for (i = 0; i < flag; i++)
		sPath[i] = DInfo.Path[i];
	sPath[i] = '\0';

	fHandle = _findfirst32(DInfo.Path,&Entrie);
	if (fHandle >= 0) i = 0; else i = -1;

	while (i == 0) {
		if (c == TList) {_findclose(fHandle);return(-8);}
		if (!(Entrie.attrib & _A_SUBDIR) || (bgiven.dplace != 3)) {
			flist[c].attrib = Entrie.attrib;
			flist[c].size = Entrie.size;

			_localtime32_s(&ftime,&Entrie.time_write);
			flist[c].tdate.second = ftime.tm_sec;
			flist[c].tdate.minute = ftime.tm_min;
			flist[c].tdate.fhour = ftime.tm_hour;
			if (ftime.tm_isdst) {
				if (flist[c].tdate.fhour > 0) --flist[c].tdate.fhour;
				else flist[c].tdate.fhour += 23;
			}
			flist[c].tdate.day = (ftime.tm_mday -1);
			flist[c].tdate.month = ftime.tm_mon;
			flist[c].tdate.year = (ftime.tm_year - 80);

			x = 0;
			if ((Entrie.name[0] == '.') && (Entrie.name[1] == '\0')) {
				while (Entrie.name[x] != '\0') flist[c].name[x] = Entrie.name[x++];
				flist[c].name[x] = '\0';
				flist[c].ext[0] = '\0';
			} else if ((Entrie.name[0] == '.') && (Entrie.name[1] == '.') && (Entrie.name[2] == '\0')) {
				while (Entrie.name[x] != '\0') flist[c].name[x] = Entrie.name[x++];
				flist[c].name[x] = '\0';
				flist[c].ext[0] = '\0';
			} else {
				while (sPath[x] != '\0') if (sPath[x++] == '\\') flag = x;
				x = 0;
				while ((Entrie.name[x] != '\0') && (flag < (_MAX_PATH - 1))) sPath[flag++] = Entrie.name[x++];
				sPath[flag] = '\0';
				if (Entrie.name[x] != '\0') {_findclose(fHandle);return(-8);}
				u = GetShortPathNameA(sPath,sPath,_MAX_PATH);
				flag = 0;
				x = 0;
				while (sPath[x] != '\0') if (sPath[x++] == '\\') flag = x;
				x = flag;
				m = 0;
				while (sPath[flag] != '\0') Entrie.name[m++] = sPath[flag++];
				Entrie.name[m] = '\0';
				sPath[x] = '\0';

				for (x = 0; x < _MAX_FNAME; x++) {
					flag = x;
					if (Entrie.name[flag] == '.') x = 10;
					else sName[flag] = Entrie.name[flag];
					if ((x < 9) && (Entrie.name[x] == '\0')) x = 20;
				}
				if (flag == (x - 1)) {
					sName[flag - 1] = '*';
					while ((Entrie.name[x] != '.') && (Entrie.name[x] != '\0')) ++x;
					m = x;
					if (Entrie.name[x] == '.') while (Entrie.name[m] != '\0') ++m;
					if (m != x) {
						if ((m - x) > 4) {
							for (m = 0; m < (_MAX_EXT - 1); m++) sName[flag++] = Entrie.name[x++];
							sName[flag++] = '*';
						} else while (Entrie.name[x] != '\0') sName[flag++] = Entrie.name[x++];
					} else sName[flag++] = '.';
				} else if (x < 20) {
					x = flag;
					while (Entrie.name[x] != '\0') ++x;
					if ((x - flag) > _MAX_EXT) {
						for (x = 0; x < (_MAX_EXT - 1); x++) sName[flag] = Entrie.name[flag++];
						sName[flag++] = '*';
					} else while (Entrie.name[flag] != '\0') sName[flag] = Entrie.name[flag++];
				}
				sName[flag] = '\0';
				flag = 0;
				while ((sName[flag] != '.') && (sName[flag] != '\0')) flist[c].name[flag] = sName[flag++];
				flist[c].name[flag] = '\0';
				if (sName[flag] != '\0') ++flag;
				x = 0;
				while (sName[flag] != '\0') flist[c].ext[x++] = sName[flag++];
				flist[c].ext[x] = '\0';
			}
		}
		++c;
		i = _findnext32(fHandle,&Entrie);
	}

	_findclose(fHandle);
	return(0);
}

